<div>
<h3>Registers</h3>

<p><em>Exemoji</em> supports <span id="reg-count">8</span> general-purpose 8bit registers:</p>

<section>
    <table class="table">
        <thead>
            <tr>
                <th>Register</th>
                <th>Index</th>
                <th>Special Use</th>
            </tr>
        </thead>
        <tbody id="registers">
        <tr><td class="centered">🐞</td>
<td class="centered">0</td>
<td>Left handside operand for mathematical operations</td></tr><tr><td class="centered">🐱</td>
<td class="centered">1</td>
<td>Right handside operand for mathematical operations</td></tr><tr><td class="centered">🐲</td>
<td class="centered">2</td>
<td>Main result for mathematical operations</td></tr><tr><td class="centered">🐦</td>
<td class="centered">3</td>
<td>Secondary result for mathematical operations</td></tr><tr><td class="centered">🐯</td>
<td class="centered">4</td>
<td/></tr><tr><td class="centered">🦄</td>
<td class="centered">5</td>
<td/></tr><tr><td class="centered">🦜</td>
<td class="centered">6</td>
<td/></tr><tr><td class="centered">🐻</td>
<td class="centered">7</td>
<td/></tr></tbody>
    </table>
</section>

<p>In addition to these, there are two 16 bit registers, the program counter (PC)
and stack pointer (SP), which are affected by specific instructions.</p>

<h3>Immediates</h3>
<section>
    <p>Immediate values can be directly encoded by bytes but this will sometimes result in invalid utf-8 sequences,
    as such there is an emoji alternative to encode immediate values</p>
    <p>A nibble can be represented by one of the following emoji:</p>

    <table class="table">
        <thead>
            <tr>
                <th>Code</th>
                <th>Hex</th>
                <th>Dec</th>
            </tr>
        </thead>
        <tbody id="immediates">
        <tr><td class="centered">🍎</td>
<td class="centered">0</td>
<td class="centered">0</td>
</tr><tr><td class="centered">🍌</td>
<td class="centered">1</td>
<td class="centered">1</td>
</tr><tr><td class="centered">🍐</td>
<td class="centered">2</td>
<td class="centered">2</td>
</tr><tr><td class="centered">🫐</td>
<td class="centered">3</td>
<td class="centered">3</td>
</tr><tr><td class="centered">🍊</td>
<td class="centered">4</td>
<td class="centered">4</td>
</tr><tr><td class="centered">🍇</td>
<td class="centered">5</td>
<td class="centered">5</td>
</tr><tr><td class="centered">🍉</td>
<td class="centered">6</td>
<td class="centered">6</td>
</tr><tr><td class="centered">🥝</td>
<td class="centered">7</td>
<td class="centered">7</td>
</tr><tr><td class="centered">🍍</td>
<td class="centered">8</td>
<td class="centered">8</td>
</tr><tr><td class="centered">🍓</td>
<td class="centered">9</td>
<td class="centered">9</td>
</tr><tr><td class="centered">🍒</td>
<td class="centered">a</td>
<td class="centered">10</td>
</tr><tr><td class="centered">🍋</td>
<td class="centered">b</td>
<td class="centered">11</td>
</tr><tr><td class="centered">🍈</td>
<td class="centered">c</td>
<td class="centered">12</td>
</tr><tr><td class="centered">🥥</td>
<td class="centered">d</td>
<td class="centered">13</td>
</tr><tr><td class="centered">🥭</td>
<td class="centered">e</td>
<td class="centered">14</td>
</tr><tr><td class="centered">🍆</td>
<td class="centered">f</td>
<td class="centered">15</td>
</tr></tbody>
    </table>

    <p>To represent a full byte (octet), you need to prefix the immediate with
    <span id="immediate-long">🍽</span> followed by two nibble emoji.</p>
</section>

<h3>Instructions</h3>
<section>
    <table class="table">
        <thead>
            <tr>
                <th>Opcode</th>
                <th>Name</th>
                <th colspan="3">Operands</th>
                <th>Description</th>
            </tr>
        </thead>
        <tbody id="instructions">
        <tr><td class="centered">🐸</td>
<td class="unbreakable">Swap</td>
<td>reg₁</td>
<td>reg₂</td>
<td></td>
<td>Swaps the value of reg₁ and reg₂</td>
</tr><tr><td class="centered">🍑</td>
<td class="unbreakable">Assign</td>
<td>reg₁</td>
<td>imm₂</td>
<td></td>
<td>Assigns imm₂ to reg₁</td>
</tr><tr><td class="centered">🎁</td>
<td class="unbreakable">Move</td>
<td>reg₁</td>
<td>reg₂</td>
<td></td>
<td>Assigns the value of reg₂ to reg₁</td>
</tr><tr><td class="centered">🫸</td>
<td class="unbreakable">Push</td>
<td>reg₁</td>
<td></td>
<td></td>
<td>Pushes reg₁ into the stack, incrementing the stack pointer</td>
</tr><tr><td class="centered">💥</td>
<td class="unbreakable">Pop</td>
<td>reg₁</td>
<td></td>
<td></td>
<td>Pops reg₁ from the stack, decrementing the stack pointer</td>
</tr><tr><td class="centered">💾</td>
<td class="unbreakable">Load from SP</td>
<td>reg₁</td>
<td>reg₂</td>
<td></td>
<td>Loads into reg₁ the memory location reg₂ bytes before the stack pointer</td>
</tr><tr><td class="centered">🧠</td>
<td class="unbreakable">Load Long</td>
<td>reg₁</td>
<td>reg₂</td>
<td>reg₃</td>
<td>Loads in reg₁ the absolute memory address obtained by combining reg₂ and reg₃</td>
</tr><tr><td class="centered">🖊</td>
<td class="unbreakable">Store Long</td>
<td>reg₁</td>
<td>reg₂</td>
<td>reg₃</td>
<td>Stores reg₁ at the absolute memory address obtained by combining reg₂ and reg₃</td>
</tr><tr><td class="centered">🍦</td>
<td class="unbreakable">Trigonometry</td>
<td></td>
<td></td>
<td></td>
<td>Polar coordinates of 🐞 as an angle (2pi = 256) and 🐱 as length, offset by 127. 🐲 will be x and 🐦 will be y</td>
</tr><tr><td class="centered">😢</td>
<td class="unbreakable">Add</td>
<td></td>
<td></td>
<td></td>
<td>Adds 🐞 to 🐱, storing the result in 🐲 and overflow in 🐦</td>
</tr><tr><td class="centered">🦊</td>
<td class="unbreakable">Subtract</td>
<td></td>
<td></td>
<td></td>
<td>Subtracts 🐱 from 🐞, storing the result in 🐲, if the result is negative, 🐦 will hold the absolute value of the negative result</td>
</tr><tr><td class="centered">🐰</td>
<td class="unbreakable">Multiply</td>
<td></td>
<td></td>
<td></td>
<td>Multiplies 🐞 to 🐱, storing the result in 🐲 and overflow in 🐦</td>
</tr><tr><td class="centered">🖕</td>
<td class="unbreakable">Divide</td>
<td></td>
<td></td>
<td></td>
<td>Divides 🐞 by 🐱, storing the result in 🐲 and remainder in 🐦</td>
</tr><tr><td class="centered">🦁</td>
<td class="unbreakable">Or</td>
<td></td>
<td></td>
<td></td>
<td>Bitwise OR between 🐞 and 🐱, storing the result in 🐲</td>
</tr><tr><td class="centered">🪢</td>
<td class="unbreakable">Not</td>
<td></td>
<td></td>
<td></td>
<td>Bitwise NOT of 🐞, storing the result in 🐲</td>
</tr><tr><td class="centered">🦝</td>
<td class="unbreakable">And</td>
<td></td>
<td></td>
<td></td>
<td>Bitwise AND between 🐞 and 🐱, storing the result in 🐲</td>
</tr><tr><td class="centered">🍕</td>
<td class="unbreakable">Xor</td>
<td></td>
<td></td>
<td></td>
<td>Bitwise XOR between 🐞 and 🐱, storing the result in 🐲</td>
</tr><tr><td class="centered">🧐</td>
<td class="unbreakable">Compare</td>
<td></td>
<td></td>
<td></td>
<td>Compares 🐞 and 🐱, storing the result in 🐲: 0 if equal, 1 if 🐱 is greater ff if 🐞 is greater</td>
</tr><tr><td class="centered">👉</td>
<td class="unbreakable">Jump forward</td>
<td>emo₁</td>
<td></td>
<td></td>
<td>Jumps forwards, if emo₁ is an immediate vaue by that many bytes, otherwise after the next occurrence of that emoji</td>
</tr><tr><td class="centered">👈</td>
<td class="unbreakable">Jump back</td>
<td>emo₁</td>
<td></td>
<td></td>
<td>Jumps backwards, if emo₁ is an immediate vaue by that many bytes, otherwise after the previous occurrence of that emoji</td>
</tr><tr><td class="centered">🤌</td>
<td class="unbreakable">Jump 0 fwd</td>
<td>emo₁</td>
<td></td>
<td></td>
<td>Jumps forwards when 🐲 is 0, if emo₁ is an immediate vaue by that many bytes, otherwise after the next occurrence of that emoji</td>
</tr><tr><td class="centered">😐</td>
<td class="unbreakable">Ignore</td>
<td>emo₁</td>
<td></td>
<td></td>
<td>Ignores emo₁</td>
</tr><tr><td class="centered">🦸</td>
<td class="unbreakable">Long Jump</td>
<td>imm₁</td>
<td>imm₂</td>
<td></td>
<td>Jumps to the absolute location obtained by combining imm₁ and imm₂</td>
</tr><tr><td class="centered">🛫</td>
<td class="unbreakable">Call</td>
<td>imm₁</td>
<td>imm₂</td>
<td></td>
<td>Pushes the program counter into the stack (most significant byte first) and jumps to the absolute location obtained by combining imm₁ and imm₂</td>
</tr><tr><td class="centered">🛬</td>
<td class="unbreakable">Pop PC</td>
<td></td>
<td></td>
<td></td>
<td>Pops the program counter from the stack (least significant byte first)</td>
</tr><tr><td class="centered">🫠</td>
<td class="unbreakable">Halt</td>
<td></td>
<td></td>
<td></td>
<td>Stops program execution</td>
</tr><tr><td class="centered">🤖</td>
<td class="unbreakable">Inerrupt</td>
<td>imm₁</td>
<td></td>
<td></td>
<td>Generates interrupt imm₁</td>
</tr></tbody>
    </table>

    <p>Some instructions take 16 bit addresses represented as a pair of operands.
        These are combined by interpreting the first operand as the most significant byte.</p>
</section>

<h3>Interrupts</h3>
<section>
    <table class="table">
        <thead>
            <tr>
                <th>Code</th>
                <th>Effect</th>
            </tr>
        </thead>
        <tbody id="interrupts">
        <tr><th colspan="2">Text Output</th>
</tr><tr><td class="centered">00</td>
<td>Prints 🐲 as a character to the output</td>
</tr><tr><th colspan="2">Graphics</th>
</tr><tr><td class="centered">10</td>
<td>Enables / clears graphics output</td>
</tr><tr><td class="centered">11</td>
<td>Sets graphics stroke color to r 🐞 g 🐱 b 🐲</td>
</tr><tr><td class="centered">12</td>
<td>Sets graphics stroke width to 🐞</td>
</tr><tr><td class="centered">13</td>
<td>Applies stroke style to the current path</td>
</tr><tr><td class="centered">14</td>
<td>Sets graphics fill color to r 🐞 g 🐱 b 🐲</td>
</tr><tr><td class="centered">15</td>
<td>Applies fill style to the current path</td>
</tr><tr><th colspan="2">Graphics Path Commands</th>
</tr><tr><td class="centered">20</td>
<td>Begins a new path</td>
</tr><tr><td class="centered">21</td>
<td>Closes the current path</td>
</tr><tr><td class="centered">22</td>
<td>Moves the path pen to x 🐞 y 🐱</td>
</tr><tr><td class="centered">23</td>
<td>Draws a line from pen position to x 🐞 y 🐱</td>
</tr></tbody>
    </table>
</section>
</div>